public class Mapa {
	public final static int IZLAZ = -5;
	public final static int ZID = -1;
	public final static int ERROR = Integer.MIN_VALUE;

	private int visina, sirina;
	private int[][] mat;
	private boolean[][] pos;

	public int getSirina() {
		return sirina;
	}

	public int getVisina() {
		return visina;
	}

	public void setPos(int x, int y, boolean b) {
		if (0 <= x && x < sirina && 0 <= y && y < visina) {
			pos[x][y] = b;
		}
	}

	public boolean getPos(int x, int y) {
		if (0 <= x && x < sirina && 0 <= y && y < visina) {
			return pos[x][y];
		} else {
			return true;
		}
	}

	public int getMat(int x, int y) {
		if (0 <= x && x < sirina && 0 <= y && y < visina) {
			return mat[x][y];
		} else {
			return ERROR;
		}
	}

	public Mapa(int sirina, int visina) {
		this.sirina = sirina;
		this.visina = visina;
		mat = new int[sirina][visina];
		pos = new boolean[sirina][visina];
	}

	public static Mapa ucitajIzFajla(String imeFajla) {
		if (!Svetovid.testIn(imeFajla)) {
			return null;
		}

		int sirina = Svetovid.in(imeFajla).readInt();
		int visina = Svetovid.in(imeFajla).readInt();
		if (sirina >= 0 && visina >= 0) {
			Mapa res = new Mapa(sirina, visina);
			for (int j = 0; j < visina; j++)
				for (int i = 0; i < sirina; i++)
					res.mat[i][j] = Svetovid.in(imeFajla).readInt();
			Svetovid.closeIn(imeFajla);
			return res;
		} else {
			Svetovid.closeIn(imeFajla);
			return null;
		}
	}

	public void stampaj() {
		if (visina != 0 && sirina != 0) {
			System.out.println(visina + " " + sirina);
			for (int j = 0; j < visina; j++) {
				for (int i = 0; i < sirina; i++) {
					System.out.print(mat[i][j] + "\t");
				}
				System.out.println();
			}
		}
	}
}
